#include<bits/stdc++.h>
#define ll long long
#define pll pair<ll,ll>
#define pii pair<int,int>
#define all(data) data.begin(),data.end()
#define mp make_pair
#define INF 1e15
#define MOD 1000000007
using namespace std;
#define MAXN 100007
#define K 30
ll a[MAXN],occ[K];
int main()
{
    ios::sync_with_stdio(false); cin.tie(0);
    ll n; cin>>n;
    for(int i=1;i<=n;i++) cin>>a[i];
    for(int j=0;j<K;j++)
    {
        for(int i=1;i<=n;i++) occ[j]+=((a[i]>>j)&1);
    }
    ll q,t,k,x; cin>>q;
    while(q--)
    {
        cin>>t;
        if(t==0)
        {
            cin>>k;
            ll rez=0;
            for(int j=0;j<K;j++)
            {
                if(occ[j]>=k) rez+=(1<<j);
            }
            cout<<rez<<endl;
        }
        else
        {
            cin>>k>>x;
            for(int j=0;j<K;j++)
            {
                occ[j]-=((a[k]>>j)&1);
            }
            a[k]=x;
            for(int j=0;j<K;j++)
            {
                occ[j]+=((a[k]>>j)&1);
            }
        }
    }
    return 0;
}